package smartresource.core;

import java.util.*;
import javax.swing.*;
import java.awt.Frame;

public abstract class SmartResourceAgentGUI extends JFrame implements ParametrizedAsset{

	public SmartResourceAgent myAgent;

	Vector startParameters;

	public void setStartParameters(Vector startParams){
		startParameters=startParams;
	}

	public SmartResourceAgentGUI(){
		super();
	}

	public void setAgent(SmartResourceAgent a){
		myAgent=a;
	}

	//called after construct()
	public void start(){
	        String title=getParameterValue("title");
	        String state=getParameterValue("state");
		if(title!=null) setTitle(title);
		if(state!=null){
			if(state.equals("minimized"))	setState(Frame.ICONIFIED);
		      	else if(state.equals("maximized")) setState(Frame.MAXIMIZED_BOTH); 
		}
		setVisible(true);
	}


//To be overrided in subclasses

	public abstract void construct();

	public void modify(){}



// Interface to subclasses

	public String getParameterValue(String name){
		return getParameterValue(name, null);
	}

	public String getParameterValue(String name, String ns){
	        if(startParameters!=null){
			Iterator it=startParameters.iterator(); 
			while(it.hasNext()){ 
				BehaviorStartParameter p=(BehaviorStartParameter)it.next();
				if(name.equals(p.name))
					if(ns==null || ns.equals(p.name_ns))
						return p.value;
			}
		}
		return null;
	}

	public Vector getParameterValues(String name){
		return getParameterValues(name, null);
	}

	public Vector getParameterValues(String name, String ns){
	        Vector values=new Vector();
	        if(startParameters!=null){
			Iterator it=startParameters.iterator(); 
			while(it.hasNext()){ 
				BehaviorStartParameter p=(BehaviorStartParameter)it.next();
				if(name.equals(p.name)) 
					if(ns==null || ns.equals(p.name_ns))
						values.add(p.value);
			}
		}
		return values;
	}

}
