package smartresource.core;

import java.net.*;
import java.io.*;
import java.util.StringTokenizer;
import java.util.Vector;
import java.util.Iterator;

class SmartResourceAgentServer implements Runnable, ParametrizedAsset
{
	SmartResourceAgent myAgent;

	Thread m_Server = null;
	public ServerSocket s_soc;
	int listenerPort=8090;

	Vector startParameters;

	public SmartResourceAgentServer(){}

	public void setStartParameters(Vector startParams){
		startParameters=startParams;
	}

	public void setAgent(SmartResourceAgent a){
		myAgent=a;
	}

	public void setPort(int port){
		listenerPort=port;
	}

	public void start()
	{
	        String port=null;
		Iterator itt=startParameters.iterator(); 
		while(itt.hasNext()){ 
			BehaviorStartParameter p=(BehaviorStartParameter)itt.next();
			if(p.name.equals("port")) port=p.value;
		}
		if(port!=null){
			int iPort=new Integer(port).intValue();
			setPort(iPort);
		}
		
		if (m_Server == null)
		{
			m_Server = new Thread(this);
			m_Server.start();
		}
	}

	public void stop()
	{
		if (m_Server != null)
		{
			try{
				s_soc.close();
			}catch(IOException e){e.printStackTrace();}
		}
	}

	public void run()
	{
		try{
			s_soc=new ServerSocket(listenerPort,10);
		}catch(IOException e){e.printStackTrace();stop();}

		while (!s_soc.isClosed())
		{
			boolean OK=true;
			Socket c_soc=null;
			
			try{
				c_soc=s_soc.accept();
			}catch(IOException e){OK=false;}

			if(OK){
			   new Thread(new Handler(c_soc)).start();
			}

		}
	}//run

	private class Handler implements Runnable{
	                Socket c_soc;
	                Handler(Socket soc){c_soc=soc;} 

			public void run() {

				String getBody="";
				try{
					InputStream input=c_soc.getInputStream();
					InputStreamReader ff=new InputStreamReader(input);
					String str1="";
					int ch;

					boolean reqOK=false;
					for(int i=0;i<100000;i++){
						if(ff.ready()){
							reqOK=true;
							break;
						}
					}
					
					if(reqOK){
						while(ff.ready()){
							ch=(char)ff.read();
							if(ch!=-1) str1+=(char)ch;
							else break;
						}

						StringTokenizer t = new StringTokenizer(str1,"\n");
						String strGet=t.nextToken();
						int iStart=-1;
						try{
							iStart=strGet.indexOf("GET");
						}catch(NullPointerException e){};

						iStart=iStart+3;

						int iEnd=-1;
						try{
							iEnd=strGet.lastIndexOf("HTTP");
						}catch(NullPointerException e){};
						if(iEnd==-1){
							iEnd=strGet.length()-1;
						}
						else{
							iEnd=iEnd-1;
						}
						getBody=strGet.substring(iStart,iEnd).trim();
						getBody=getBody.substring(1);

						myAgent.postServerEvent(new ServerEvent(getBody,c_soc));

					}
					else c_soc.close();


				}catch(IOException e){e.printStackTrace();}
			}
	}

}
