package smartresource.core.behaviors;

import smartresource.core.*;

import java.io.File;

public class OntologyLookupBehavior extends ReusableAtomicBehavior{

	public void action() {

		String type=getParameterValue("searchType");
		String search=getParameterValue("searchValue");
		String resultTo=getParameterValue("resultTo");
		
		String result_name="";
		String result_ext="";
		if(type.equals("GetScript")){
			result_name="DB/_ontology/"+search;
			result_ext=".rdf";
		}
		else if(type.equals("GetClass")){
			result_name="DB/_ontology/classes/"+search;
			result_ext=".class";
		}

                File datafile=new File(result_name+result_ext);
                if(!datafile.exists()){
	                result_ext=".zip";
	                datafile=new File(result_name+result_ext);
	                if(!datafile.exists()){
		                success=false;
		                return;
		        }
                }

		SemanticStatement res=new SemanticStatement(resultTo);
		if(res.isSubjectUndefined()) res.subject=result_name+result_ext;
		if(res.isPredicateUndefined()) res.predicate=result_name+result_ext;
		if(res.isObjectUndefined()) res.object=result_name+result_ext;
		addBelief(res);
	}
  }
