package smartresource.core.behaviors;

import smartresource.core.*;

import java.util.Vector;
import java.util.Iterator;

import jade.core.AID;

import jade.domain.DFService;
import jade.domain.FIPAException;
import jade.domain.FIPAAgentManagement.DFAgentDescription;
import jade.domain.FIPAAgentManagement.ServiceDescription;

public class SecurityCheckBehavior extends ReusableAtomicBehavior{

   public void action() {

	Vector allowedFrom=getParameterValues("allowed");
	String from=getParameterValue("agent");

	boolean OK=false;
	
        DFAgentDescription template = new DFAgentDescription();
	template.setName(new AID(from, AID.ISLOCALNAME));
	String auth_role="";
        try{
        	DFAgentDescription[] result = DFService.search(myAgent, template); 
		if(result.length==1){
			Iterator it=result[0].getAllServices();
			while(it.hasNext()){ 
				String hasRole=((ServiceDescription)it.next()).getName();
				if(allowedFrom.contains(hasRole)){
					OK=true; 
					auth_role=hasRole;
				}
			}
		}
        }catch (FIPAException fe) {
        	fe.printStackTrace();
        	success=false;
        	return;
        }


	if(OK){
		print(from+" is authorized as an "+auth_role);
	}
	else{
		success=false;
		print(from+" has not been authorized!");
	}
   }

}
