package smartresource.core.util;

import java.io.*;

/**
Instance of this class is set by system as standard output and error streams.
It writes all output to both old stream and specified stream (for example to file).
*/	
public class Logger extends PrintStream{
	/**
	Old output stream.
	*/	
	public PrintStream oldOut;

	/**
	Creates instance of class.
	@param out output stream where to write
	*/	
	public Logger(OutputStream out){
		super(out);
	}

	/**
	Writes data to both old stream and new stream
	@param b array of bytes that contains data to write
	@param off start position of data in array
	@param len number of bytes to write
	*/	
    public void write(byte  b[], int  off, int  len){ 
		oldOut.write(b,off,len); 
		super.write(b,off,len);
	}
}