package smartresource.shared;

import smartresource.core.*;

public class DelayerBehavior extends ReusableAtomicBehavior{

	long waitTill=0;

	public void onStart(){
		finished=false;
		String delay=getParameterValue("delay");
		delay.equals(""); //to cause exception if null

		long toWait=new Long(delay).longValue();
		long now=System.currentTimeMillis();
		waitTill=now+toWait;
		block(toWait);
	}

	public void action(){
		long now=System.currentTimeMillis();
		if(now>=waitTill) finished=true;
		else block(waitTill-now);
	}
}
	